<?xml version="1.0" encoding="UTF-8"?>
<bpmn2:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://www.omg.org/bpmn20" xmlns:bpmn2="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:bpsim="http://www.bpsim.org/schemas/1.0" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:drools="http://www.jboss.org/drools" id="_rl5lsGFREeyn6KTw5hREWA" xsi:schemaLocation="http://www.omg.org/spec/BPMN/20100524/MODEL BPMN20.xsd http://www.jboss.org/drools drools.xsd http://www.bpsim.org/schemas/1.0 bpsim.xsd http://www.omg.org/spec/DD/20100524/DC DC.xsd http://www.omg.org/spec/DD/20100524/DI DI.xsd " exporter="jBPM Process Modeler" exporterVersion="2.0" targetNamespace="http://www.omg.org/bpmn20">
  <bpmn2:itemDefinition id="_OutRowDataItem" structureRef="java.util.ArrayList"/>
  <bpmn2:itemDefinition id="_RequestMapItem" structureRef="java.util.Map"/>
  <bpmn2:itemDefinition id="_approvalRequestItem" structureRef="com.example.t51365.model.ApprovalRequest"/>
  <bpmn2:itemDefinition id="_approvalDecisionItem" structureRef="com.example.t51365.model.ApprovalRequest"/>
  <bpmn2:itemDefinition id="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_namespaceInputXItem" structureRef="java.lang.String"/>
  <bpmn2:itemDefinition id="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_modelInputXItem" structureRef="java.lang.String"/>
  <bpmn2:itemDefinition id="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_decisionInputXItem" structureRef="java.lang.String"/>
  <bpmn2:itemDefinition id="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalRequestInputXItem" structureRef="java.util.Map"/>
  <bpmn2:itemDefinition id="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalDecisionOutputXItem" structureRef="java.util.ArrayList"/>
  <bpmn2:process id="morf2.ag_flow2" drools:packageName="com.test.rule_flows.rule_flows" drools:version="1.0" drools:adHoc="false" name="ag_flow" isExecutable="true" processType="Public">
    <bpmn2:extensionElements>
      <drools:import name="java.util.Map"/>
      <drools:import name="java.util.ArrayList"/>
      <drools:import name="com.example.t51365.model.RowData"/>
    </bpmn2:extensionElements>
    <bpmn2:property id="OutRowData" itemSubjectRef="_OutRowDataItem" name="OutRowData"/>
    <bpmn2:property id="RequestMap" itemSubjectRef="_RequestMapItem" name="RequestMap"/>
    <bpmn2:property id="approvalRequest" itemSubjectRef="_approvalRequestItem" name="approvalRequest"/>
    <bpmn2:property id="approvalDecision" itemSubjectRef="_approvalDecisionItem" name="approvalDecision"/>
    <bpmn2:sequenceFlow id="_91EB7D44-B13C-413D-A8C8-89EF4B0FEFEC" sourceRef="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE" targetRef="_A6E13DFF-AEEA-4628-8833-5B79EFAFC824">
      <bpmn2:extensionElements>
        <drools:metaData name="isAutoConnection.source">
          <drools:metaValue><![CDATA[true]]></drools:metaValue>
        </drools:metaData>
        <drools:metaData name="isAutoConnection.target">
          <drools:metaValue><![CDATA[true]]></drools:metaValue>
        </drools:metaData>
      </bpmn2:extensionElements>
    </bpmn2:sequenceFlow>
    <bpmn2:sequenceFlow id="_AFD39B78-548C-4FD5-9D16-86706D2141B8" sourceRef="_79BE80A7-18E1-436C-B037-E10B55212F63" targetRef="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE"/>
    <bpmn2:sequenceFlow id="_1313830F-7666-46DD-AFD2-E912CC337A18" sourceRef="_7C82A203-95DC-4CB1-959A-CB84B073368B" targetRef="_79BE80A7-18E1-436C-B037-E10B55212F63">
      <bpmn2:extensionElements>
        <drools:metaData name="isAutoConnection.source">
          <drools:metaValue><![CDATA[true]]></drools:metaValue>
        </drools:metaData>
        <drools:metaData name="isAutoConnection.target">
          <drools:metaValue><![CDATA[true]]></drools:metaValue>
        </drools:metaData>
      </bpmn2:extensionElements>
    </bpmn2:sequenceFlow>
    <bpmn2:startEvent id="_7C82A203-95DC-4CB1-959A-CB84B073368B">
      <bpmn2:outgoing>_1313830F-7666-46DD-AFD2-E912CC337A18</bpmn2:outgoing>
    </bpmn2:startEvent>
    <bpmn2:endEvent id="_A6E13DFF-AEEA-4628-8833-5B79EFAFC824">
      <bpmn2:incoming>_91EB7D44-B13C-413D-A8C8-89EF4B0FEFEC</bpmn2:incoming>
    </bpmn2:endEvent>
    <bpmn2:businessRuleTask id="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE" name="Approval" implementation="http://www.jboss.org/drools/dmn">
      <bpmn2:extensionElements>
        <drools:metaData name="elementname">
          <drools:metaValue><![CDATA[Approval]]></drools:metaValue>
        </drools:metaData>
        <drools:onEntry-script scriptFormat="http://www.java.com/java">
          <drools:script><![CDATA[System.out.println("APPROVAL DMN ENTRY");
java.util.Collection c = kcontext.getKieRuntime().getObjects();
System.out.println("DMN ENTRY: Size of Collection:"+c.size());
]]></drools:script>
        </drools:onEntry-script>
        <drools:onExit-script scriptFormat="http://www.java.com/java">
          <drools:script><![CDATA[System.out.println("APPROVAL DMN EXIT");

System.out.println("KCONTEXT VARIABLE OutRowData:"+kcontext.getVariable("OutRowData"));
System.out.println("KCONTEXT VARIABLE OutRowData.class:"+kcontext.getVariable("OutRowData").getClass());
com.example.t51365.model.ApprovalRequest ar = null;
java.util.Collection c = kcontext.getKieRuntime().getObjects();
System.out.println("Printing kcontext.getKieRuntime().getObjects(): Size of Collection:"+c.size());
for (Object o : c) {
    if (o instanceof com.example.t51365.model.ApprovalRequest) {
        ar = (com.example.t51365.model.ApprovalRequest) o;
    }
    System.out.println ("Fact " + o.getClass()+"    Value:"+o.toString());
}
ar.setDecision(kcontext.getVariable("OutRowData")==null?null:kcontext.getVariable("OutRowData").toString());
]]></drools:script>
        </drools:onExit-script>
      </bpmn2:extensionElements>
      <bpmn2:incoming>_AFD39B78-548C-4FD5-9D16-86706D2141B8</bpmn2:incoming>
      <bpmn2:outgoing>_91EB7D44-B13C-413D-A8C8-89EF4B0FEFEC</bpmn2:outgoing>
      <bpmn2:ioSpecification id="_rl5lsWFREeyn6KTw5hREWA">
        <bpmn2:dataInput id="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_namespaceInputX" drools:dtype="java.lang.String" itemSubjectRef="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_namespaceInputXItem" name="namespace"/>
        <bpmn2:dataInput id="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_decisionInputX" drools:dtype="java.lang.String" itemSubjectRef="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_decisionInputXItem" name="decision"/>
        <bpmn2:dataInput id="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_modelInputX" drools:dtype="java.lang.String" itemSubjectRef="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_modelInputXItem" name="model"/>
        <bpmn2:dataInput id="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalRequestInputX" drools:dtype="java.util.Map" itemSubjectRef="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalRequestInputXItem" name="ApprovalRequest"/>
        <bpmn2:dataOutput id="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalDecisionOutputX" drools:dtype="java.util.ArrayList" itemSubjectRef="__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalDecisionOutputXItem" name="ApprovalDecision"/>
        <bpmn2:inputSet id="_rl5lsmFREeyn6KTw5hREWA">
          <bpmn2:dataInputRefs>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_namespaceInputX</bpmn2:dataInputRefs>
          <bpmn2:dataInputRefs>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_decisionInputX</bpmn2:dataInputRefs>
          <bpmn2:dataInputRefs>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_modelInputX</bpmn2:dataInputRefs>
          <bpmn2:dataInputRefs>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalRequestInputX</bpmn2:dataInputRefs>
        </bpmn2:inputSet>
        <bpmn2:outputSet id="_rl5ls2FREeyn6KTw5hREWA">
          <bpmn2:dataOutputRefs>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalDecisionOutputX</bpmn2:dataOutputRefs>
        </bpmn2:outputSet>
      </bpmn2:ioSpecification>
      <bpmn2:dataInputAssociation id="_rl5ltGFREeyn6KTw5hREWA">
        <bpmn2:targetRef>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_namespaceInputX</bpmn2:targetRef>
        <bpmn2:assignment id="_rl5ltWFREeyn6KTw5hREWA">
          <bpmn2:from xsi:type="bpmn2:tFormalExpression" id="_rl5ltmFREeyn6KTw5hREWA"><![CDATA[https://kiegroup.org/dmn/_E19245A7-5775-469D-9A0F-8F81210F1F43]]></bpmn2:from>
          <bpmn2:to xsi:type="bpmn2:tFormalExpression" id="_rl5lt2FREeyn6KTw5hREWA">_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_namespaceInputX</bpmn2:to>
        </bpmn2:assignment>
      </bpmn2:dataInputAssociation>
      <bpmn2:dataInputAssociation id="_rl5luGFREeyn6KTw5hREWA">
        <bpmn2:targetRef>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_decisionInputX</bpmn2:targetRef>
        <bpmn2:assignment id="_rl5luWFREeyn6KTw5hREWA">
          <bpmn2:from xsi:type="bpmn2:tFormalExpression" id="_rl5lumFREeyn6KTw5hREWA"><![CDATA[ApprovalDecision]]></bpmn2:from>
          <bpmn2:to xsi:type="bpmn2:tFormalExpression" id="_rl5lu2FREeyn6KTw5hREWA">_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_decisionInputX</bpmn2:to>
        </bpmn2:assignment>
      </bpmn2:dataInputAssociation>
      <bpmn2:dataInputAssociation id="_rl5lvGFREeyn6KTw5hREWA">
        <bpmn2:targetRef>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_modelInputX</bpmn2:targetRef>
        <bpmn2:assignment id="_rl5lvWFREeyn6KTw5hREWA">
          <bpmn2:from xsi:type="bpmn2:tFormalExpression" id="_rl5lvmFREeyn6KTw5hREWA"><![CDATA[ar_ag2]]></bpmn2:from>
          <bpmn2:to xsi:type="bpmn2:tFormalExpression" id="_rl5lv2FREeyn6KTw5hREWA">_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_modelInputX</bpmn2:to>
        </bpmn2:assignment>
      </bpmn2:dataInputAssociation>
      <bpmn2:dataInputAssociation id="_rl5lwGFREeyn6KTw5hREWA">
        <bpmn2:sourceRef>RequestMap</bpmn2:sourceRef>
        <bpmn2:targetRef>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalRequestInputX</bpmn2:targetRef>
      </bpmn2:dataInputAssociation>
      <bpmn2:dataOutputAssociation id="_rl5lwWFREeyn6KTw5hREWA">
        <bpmn2:sourceRef>_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_ApprovalDecisionOutputX</bpmn2:sourceRef>
        <bpmn2:targetRef>OutRowData</bpmn2:targetRef>
      </bpmn2:dataOutputAssociation>
    </bpmn2:businessRuleTask>
    <bpmn2:scriptTask id="_79BE80A7-18E1-436C-B037-E10B55212F63" name="Prepare" scriptFormat="http://www.java.com/java">
      <bpmn2:extensionElements>
        <drools:metaData name="elementname">
          <drools:metaValue><![CDATA[Prepare]]></drools:metaValue>
        </drools:metaData>
      </bpmn2:extensionElements>
      <bpmn2:incoming>_1313830F-7666-46DD-AFD2-E912CC337A18</bpmn2:incoming>
      <bpmn2:outgoing>_AFD39B78-548C-4FD5-9D16-86706D2141B8</bpmn2:outgoing>
      <bpmn2:script><![CDATA[System.out.println("PREPARE ENTRY");
java.util.Collection c = kcontext.getKieRuntime().getObjects();
System.out.println("DMN ENTRY: Size of Collection:"+c.size());
com.example.t51365.model.ApprovalRequest ar = new com.example.t51365.model.ApprovalRequest();
for (Object o : c) {
    System.out.println ("Fact " + o.getClass());
    if (o instanceof com.example.t51365.model.ApprovalRequest) {
      ar = (com.example.t51365.model.ApprovalRequest) o;
    }
}
java.util.Map _driver = new java.util.HashMap();
_driver.put("requestNumber", ar.getRequestNumber());
_driver.put("rowData", ar.getRowData());
kcontext.setVariable("RequestMap", _driver);]]></bpmn2:script>
    </bpmn2:scriptTask>
  </bpmn2:process>
  <bpmndi:BPMNDiagram id="_rl5lwmFREeyn6KTw5hREWA">
    <bpmndi:BPMNPlane id="_rl5lw2FREeyn6KTw5hREWA" bpmnElement="morf2.ag_flow2">
      <bpmndi:BPMNShape id="shape__79BE80A7-18E1-436C-B037-E10B55212F63" bpmnElement="_79BE80A7-18E1-436C-B037-E10B55212F63">
        <dc:Bounds height="102.0" width="154.0" x="260.0" y="170.0"/>
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="shape__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE" bpmnElement="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE">
        <dc:Bounds height="102.0" width="154.0" x="500.0" y="170.0"/>
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="shape__A6E13DFF-AEEA-4628-8833-5B79EFAFC824" bpmnElement="_A6E13DFF-AEEA-4628-8833-5B79EFAFC824">
        <dc:Bounds height="56.0" width="56.0" x="784.0" y="193.0"/>
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="shape__7C82A203-95DC-4CB1-959A-CB84B073368B" bpmnElement="_7C82A203-95DC-4CB1-959A-CB84B073368B">
        <dc:Bounds height="56.0" width="56.0" x="107.0" y="193.0"/>
      </bpmndi:BPMNShape>
      <bpmndi:BPMNEdge id="edge_shape__7C82A203-95DC-4CB1-959A-CB84B073368B_to_shape__79BE80A7-18E1-436C-B037-E10B55212F63" bpmnElement="_1313830F-7666-46DD-AFD2-E912CC337A18">
        <di:waypoint xsi:type="dc:Point" x="135.0" y="249.0"/>
        <di:waypoint xsi:type="dc:Point" x="337.0" y="170.0"/>
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="edge_shape__79BE80A7-18E1-436C-B037-E10B55212F63_to_shape__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE" bpmnElement="_AFD39B78-548C-4FD5-9D16-86706D2141B8">
        <di:waypoint xsi:type="dc:Point" x="337.0" y="221.0"/>
        <di:waypoint xsi:type="dc:Point" x="500.0" y="221.0"/>
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="edge_shape__E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE_to_shape__A6E13DFF-AEEA-4628-8833-5B79EFAFC824" bpmnElement="_91EB7D44-B13C-413D-A8C8-89EF4B0FEFEC">
        <di:waypoint xsi:type="dc:Point" x="654.0" y="221.0"/>
        <di:waypoint xsi:type="dc:Point" x="784.0" y="221.0"/>
      </bpmndi:BPMNEdge>
    </bpmndi:BPMNPlane>
  </bpmndi:BPMNDiagram>
  <bpmn2:relationship id="_rl5lxGFREeyn6KTw5hREWA" type="BPSimData">
    <bpmn2:extensionElements>
      <bpsim:BPSimData>
        <bpsim:Scenario xsi:type="bpsim:Scenario" id="default" name="Simulationscenario">
          <bpsim:ScenarioParameters xsi:type="bpsim:ScenarioParameters"/>
          <bpsim:ElementParameters xsi:type="bpsim:ElementParameters" elementRef="_79BE80A7-18E1-436C-B037-E10B55212F63" id="_rl5lxWFREeyn6KTw5hREWA">
            <bpsim:TimeParameters xsi:type="bpsim:TimeParameters">
              <bpsim:ProcessingTime xsi:type="bpsim:Parameter">
                <bpsim:NormalDistribution mean="0.0" standardDeviation="0.0"/>
              </bpsim:ProcessingTime>
            </bpsim:TimeParameters>
            <bpsim:ResourceParameters xsi:type="bpsim:ResourceParameters">
              <bpsim:Availability xsi:type="bpsim:Parameter">
                <bpsim:FloatingParameter value="0.0"/>
              </bpsim:Availability>
              <bpsim:Quantity xsi:type="bpsim:Parameter">
                <bpsim:FloatingParameter value="0.0"/>
              </bpsim:Quantity>
            </bpsim:ResourceParameters>
            <bpsim:CostParameters xsi:type="bpsim:CostParameters">
              <bpsim:UnitCost xsi:type="bpsim:Parameter">
                <bpsim:FloatingParameter value="0.0"/>
              </bpsim:UnitCost>
            </bpsim:CostParameters>
          </bpsim:ElementParameters>
          <bpsim:ElementParameters xsi:type="bpsim:ElementParameters" elementRef="_E6644CE6-49B3-42D7-BDC8-EFCF2FDCFDCE" id="_rl5lxmFREeyn6KTw5hREWA">
            <bpsim:TimeParameters xsi:type="bpsim:TimeParameters">
              <bpsim:ProcessingTime xsi:type="bpsim:Parameter">
                <bpsim:NormalDistribution mean="0.0" standardDeviation="0.0"/>
              </bpsim:ProcessingTime>
            </bpsim:TimeParameters>
            <bpsim:ResourceParameters xsi:type="bpsim:ResourceParameters">
              <bpsim:Availability xsi:type="bpsim:Parameter">
                <bpsim:FloatingParameter value="0.0"/>
              </bpsim:Availability>
              <bpsim:Quantity xsi:type="bpsim:Parameter">
                <bpsim:FloatingParameter value="0.0"/>
              </bpsim:Quantity>
            </bpsim:ResourceParameters>
            <bpsim:CostParameters xsi:type="bpsim:CostParameters">
              <bpsim:UnitCost xsi:type="bpsim:Parameter">
                <bpsim:FloatingParameter value="0.0"/>
              </bpsim:UnitCost>
            </bpsim:CostParameters>
          </bpsim:ElementParameters>
          <bpsim:ElementParameters xsi:type="bpsim:ElementParameters" elementRef="_7C82A203-95DC-4CB1-959A-CB84B073368B" id="_rl5lx2FREeyn6KTw5hREWA">
            <bpsim:TimeParameters xsi:type="bpsim:TimeParameters">
              <bpsim:ProcessingTime xsi:type="bpsim:Parameter">
                <bpsim:NormalDistribution mean="0.0" standardDeviation="0.0"/>
              </bpsim:ProcessingTime>
            </bpsim:TimeParameters>
          </bpsim:ElementParameters>
        </bpsim:Scenario>
      </bpsim:BPSimData>
    </bpmn2:extensionElements>
    <bpmn2:source>_rl5lsGFREeyn6KTw5hREWA</bpmn2:source>
    <bpmn2:target>_rl5lsGFREeyn6KTw5hREWA</bpmn2:target>
  </bpmn2:relationship>
</bpmn2:definitions>
